package eu.decideh2020.ACSmI.monitoring.client.api;

import eu.decideh2020.ACSmI.monitoring.client.model.Resourcemonitoring;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;
import java.util.Map;
import javax.ws.rs.*;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.MediaType;
import org.apache.cxf.jaxrs.ext.multipart.*;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponses;
import io.swagger.annotations.ApiResponse;
import io.swagger.jaxrs.PATCH;

/**
 * Swagger Server
 *
 * <p>ACSmI monitoring API documentation.This API describes the methods to access the ACSmI monitoring functionalities
 *
 */
@Path("/")
@Api(value = "/", description = "")
public interface ResourcemonitoringApi  {

    /**
     * createResourcemonitoring
     *
     * Creates a resourcemonitoring to be included in ACSmI monitoring
     *
     */
    @POST
    @Path("/api/resourcemonitoring")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @ApiOperation(value = "createResourcemonitoring", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Resource monitoring Created", response = Resourcemonitoring.class),
        @ApiResponse(code = 401, message = "Unauthorized"),
        @ApiResponse(code = 403, message = "Forbidden"),
        @ApiResponse(code = 404, message = "Not Found") })
    public Resourcemonitoring createResourcemonitoringUsingPOST(Resourcemonitoring body);

    /**
     * deleteResourcemonitoring
     *
     * 
     *
     */
    @DELETE
    @Path("/api/resourcemonitoring/{resourceid}")
    @Consumes({ "application/json" })
    @Produces({ "*/*" })
    @ApiOperation(value = "deleteResourcemonitoring", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Resorcemonitoring deleted form the monitoring list"),
        @ApiResponse(code = 204, message = "No Content"),
        @ApiResponse(code = 401, message = "Unauthorized"),
        @ApiResponse(code = 403, message = "Forbidden") })
    public void deleteResourcemonitoringUsingDELETE(@PathParam("resourceid") String resourceid);

    /**
     * getResourcemonitoringstatus
     *
     * Gets the status wrt monitoring of a given resource
     *
     */
    @GET
    @Path("/api/resourcemonitoring/{resourceid}")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @ApiOperation(value = "getResourcemonitoringstatus", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Specific resource monitoring is returned", response = Resourcemonitoring.class),
        @ApiResponse(code = 401, message = "Unauthorized"),
        @ApiResponse(code = 403, message = "Forbidden"),
        @ApiResponse(code = 404, message = "Not Found") })
    public Resourcemonitoring getResourcemonitoringUsingGET(@PathParam("resourceid") Integer resourceid);

    /**
     * updateResource
     *
     * Updates the monitoring status of a given resource
     *
     */
    @PUT
    @Path("/api/resourcemonitoring/{resourceid}")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @ApiOperation(value = "updateResource", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Resource Status updated", response = Resourcemonitoring.class),
        @ApiResponse(code = 401, message = "Unauthorized"),
        @ApiResponse(code = 403, message = "Forbidden"),
        @ApiResponse(code = 404, message = "Not Found") })
    public Resourcemonitoring updateResourceUsingPUT(@PathParam("resourceid") String resourceid);
}

