/****************************************************************
*Copyright (c) 2018 Tecnalia.
*Licensed under MIT License (the "License");
*Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:
*The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.
*
*
*THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*Contributors (in alphabetical order):
*Alberto Molinuevo 								Tecnalia
*Gorka Benguria                                 Tecnalia
*Iñaki Etxaniz                                  Tecnalia
*Juncal Alonso                                  Tecnalia
*Leire Orue-Echevarria                          Tecnalia
*Maria Jose Lopez                               Tecnalia
*Marisa Escalante                               Tecnalia
*
*Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*****************************************************************************/
package eu.decideh2020.acsmi.monitoring.server.api.impl;

import java.util.ArrayList;
import java.util.List;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Path;
import java.nio.file.Paths;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.omg.CORBA.VM_ABSTRACT;

import eu.DECIDEh2020.appManager.AppManager;
import eu.DECIDEh2020.appManager.exceptions.AppManagerException;
import eu.DECIDEh2020.appManager.exceptions.DECIDEValidationException;
import eu.DECIDEh2020.appManager.models.AppDescription;
import eu.decideh2020.acsmi.monitoring.server.api.*;
import eu.decideh2020.acsmi.monitoring.server.model.*;
import eu.decideh2020.acsmi.monitoring.server.api.impl.ApiApiServiceImpl;

import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.validation.constraints.*;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2018-11-06T10:38:30.646Z")


public class ApiApiServiceImpl extends ApiApiService {
	//Creating a list for the application monitoring objects
	ArrayList<Resourcemonitoring> ResourceMonitoringlist = new ArrayList<Resourcemonitoring>();
	
    @Override
    public Response createResourcemonitoringUsingPOST(Resourcemonitoring resourcemonitoring, SecurityContext securityContext) throws NotFoundException {
        ResourceMonitoringlist.add(resourcemonitoring);
    	//resourcemonitoring.setStatus("Monitored");
    	// Assign a number to the resourceid the appdescinstance//
          // assign where to save the appdesc in local
    	String localAppDesc = "";
		localAppDesc = System.getProperty("java.io.tmpdir");
		localAppDesc = localAppDesc+"\\"+System.currentTimeMillis();
		Path localappdescpath=Paths.get(localAppDesc);
		// Repository where the app description is... When integrated it will be resourcemonitoring.appdescuri
		//Local DECIDE.json
		String gitRef="https://git.code.tecnalia.com/XXXX.git";
		// Introduce the user and password of the repository where the DECIDE.json is
		String gitusername="XXX";
		String gitpassword="XXX";
		//open appManager
		AppManager appManager = null;
		try {
			appManager = AppManager.open(gitRef, gitusername, gitpassword, localappdescpath);
			appManager.setDescriptor("acsmimonitoring/DECIDE.json");
		} catch (AppManagerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// get the AppDescription		
		AppDescription appDescription = null;
		try {
			appDescription = appManager.getAppDescription();
		} catch (DECIDEValidationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// identify this resourcemonitoring with an AppIsntance
		String AppInstance = appDescription.getApplicationInstanceId();
		resourcemonitoring.setResourceid(AppInstance);
		resourcemonitoring.setStatus("Monitored");
		ResourceMonitoringlist.add(resourcemonitoring);
		// Call to configure telegraf
		monitoringconfiguration currentconfiguration= new monitoringconfiguration ();
		currentconfiguration.configuretelegraf(appDescription);
		
		System.out.println("\n\n");
		for (MonitoredVm vm : monitoringconfiguration.listcsip) {
			System.out.println(vm.getCsId());
			System.out.println(vm.getdockerHostPublicIP());
			System.out.println(vm.getAppinstanceId());
		}
		System.out.println("\n\n");

		return Response.ok(resourcemonitoring).build();
    }
    @Override
    public Response deleteResourcemonitoringUsingDELETE(String resourceid, SecurityContext securityContext) throws NotFoundException {
        // do some magic!
    	for (int i = 0;  i<ResourceMonitoringlist.size(); i++ ){
    		if (ResourceMonitoringlist.get(i).getResourceid().equals(resourceid)){
    			ResourceMonitoringlist.get(i).setStatus("Stopped");
    			stopresourcemonitoring stopcurrentmonitoring = new stopresourcemonitoring();
    			stopcurrentmonitoring.stop (resourceid);    		}    		
    	}
    	 
    	return Response.ok(ResourceMonitoringlist).build();
    }
    @Override
    public Response getResourcemonitoringUsingGET(Integer resourceid, SecurityContext securityContext) throws NotFoundException {
        // do some magic!
        return Response.ok().entity(new ApiResponseMessage(ApiResponseMessage.OK, "magic!")).build();
    }
    @Override
    public Response updateResourceUsingPUT(String resourceid, SecurityContext securityContext) throws NotFoundException {
        // do some magic!
        return Response.ok().entity(new ApiResponseMessage(ApiResponseMessage.OK, "magic!")).build();
    }
}
