package eu.decideh2020.adapt.violationhandler.client.model;


import io.swagger.annotations.ApiModelProperty;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import com.fasterxml.jackson.annotation.JsonProperty;

public class Violation  {
  
  @ApiModelProperty(value = "")
  private Long id = null;

  @ApiModelProperty(value = "Uri of the application description location")
 /**
   * Uri of the application description location  
  **/
  private String appDescUri = null;

  @ApiModelProperty(value = "Id of the serice where violation occurs")
 /**
   * Id of the serice where violation occurs  
  **/
  private String serviceId = null;

  @ApiModelProperty(value = "Affected NFR name")
 /**
   * Affected NFR name  
  **/
  private String nfr = null;

  @ApiModelProperty(value = "Status of the violation")
 /**
   * Status of the violation  
  **/
  private String status = null;

  @ApiModelProperty(value = "Violation source type, SLA (0) or CSP (1)")
 /**
   * Violation source type, SLA (0) or CSP (1)  
  **/
  private Integer type = null;

  @ApiModelProperty(value = "Timestamp with the violation monitoring time")
 /**
   * Timestamp with the violation monitoring time  
  **/
  private Long timestamp = null;
 /**
   * Get id
   * @return id
  **/
  @JsonProperty("id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Violation id(Long id) {
    this.id = id;
    return this;
  }

 /**
   * Uri of the application description location
   * @return appDescUri
  **/
  @JsonProperty("app_desc_uri")
  public String getAppDescUri() {
    return appDescUri;
  }

  public void setAppDescUri(String appDescUri) {
    this.appDescUri = appDescUri;
  }

  public Violation appDescUri(String appDescUri) {
    this.appDescUri = appDescUri;
    return this;
  }

 /**
   * Id of the serice where violation occurs
   * @return serviceId
  **/
  @JsonProperty("service_id")
  public String getServiceId() {
    return serviceId;
  }

  public void setServiceId(String serviceId) {
    this.serviceId = serviceId;
  }

  public Violation serviceId(String serviceId) {
    this.serviceId = serviceId;
    return this;
  }

 /**
   * Affected NFR name
   * @return nfr
  **/
  @JsonProperty("nfr")
  public String getNfr() {
    return nfr;
  }

  public void setNfr(String nfr) {
    this.nfr = nfr;
  }

  public Violation nfr(String nfr) {
    this.nfr = nfr;
    return this;
  }

 /**
   * Status of the violation
   * @return status
  **/
  @JsonProperty("status")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public Violation status(String status) {
    this.status = status;
    return this;
  }

 /**
   * Violation source type, SLA (0) or CSP (1)
   * @return type
  **/
  @JsonProperty("type")
  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public Violation type(Integer type) {
    this.type = type;
    return this;
  }

 /**
   * Timestamp with the violation monitoring time
   * @return timestamp
  **/
  @JsonProperty("timestamp")
  public Long getTimestamp() {
    return timestamp;
  }

  public void setTimestamp(Long timestamp) {
    this.timestamp = timestamp;
  }

  public Violation timestamp(Long timestamp) {
    this.timestamp = timestamp;
    return this;
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Violation {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    appDescUri: ").append(toIndentedString(appDescUri)).append("\n");
    sb.append("    serviceId: ").append(toIndentedString(serviceId)).append("\n");
    sb.append("    nfr: ").append(toIndentedString(nfr)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private static String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

