class GitAccess < ActiveRecord::Base
  belongs_to :session

  attr_encrypted :username, key: '\xF5?Y\x90\xD3K\xE4S\x01\xBB\x96H`\xB5/\x1A~x\xAF\x87o?B\xAC\xB1z\x97\xA0\xDC\x11\xBE\x8E'
  attr_encrypted :password, key: '\xC3\xEDL\x0EB\xFB\x8E\xBA\x1D\x8D\xA8\xBB\xD5\x9C\xD8\xC2@\xF5\xADD{\x1D\x8Du\x0E\xD6\xFAx,g\x17\x8A'

  alias_attribute :git_url, :url
  alias_attribute :git_username, :username
  alias_attribute :git_password, :password

  before_validation :unescape_fields
  validate :url_format
  validate :credentials_present

  DEFAULT_URL = 'https://git.code.tecnalia.com/decide/SockShop_AppDescription.git'

  def self.default_credentials(git_url)
    creds = {}
    if ENV['GIT_CREDENTIALS']
      creds[:git_username], creds[:git_password] = ENV['GIT_CREDENTIALS'].split(':', 2)
    elsif git_url.include?('git.code.tecnalia.com/')
      creds[:git_username] = 'andrey.sereda@scaletools.com'
      creds[:git_password] = 'F5W8=FtGQ4xr' # hardcode of credentials.. all for the sake of demo
    end
    creds
  end

  def ensure_valid
    raise errors.full_messages.join(', ') unless valid?
  end

  private

  def unescape_fields
    %i[git_url git_username git_password].each do |field|
      assign_attributes(field => CGI.unescape(public_send(field)))
    end
  end

  def url_format
    parsed_url = URI.parse(url) rescue false
    unless parsed_url.kind_of?(URI::HTTP) || parsed_url.kind_of?(URI::HTTPS)
      errors.add(:url, 'Invalid git url')
    end
  end

  def credentials_present
    creds = %i[username password]
    creds.each do |cred|
      next if public_send(cred).present?
      errors.add(:base, "Git #{cred.to_s} can't be blank")
    end
  end

end