class VirtualMachine < ActiveRecord::Base
  belongs_to :contracting_resource

  def description
    it_data = PlatformConnector.instance_type_data(instance_type_id)
    service = Service.new(contracting_resource.service_id)

    { 'id' => contracting_resource.index.to_s,
      'cspName' => service.attributes['Provider'][:human],
      'cspId' => service.attributes['Provider'][:value],
      'ram' =>  it_data['memory'].to_i,
      'cores' => it_data['cpus'].to_i * it_data['cpu_cores'].to_i,
      'storage' => it_data['instance-storage'].to_i,
      'image' => image,
      'vmSoftwareId' => software_id,
      'vmResourceId' => contracting_resource.resource_id,
      'vmRegionId' => region_id,
      'instanceTypeId' => instance_type_id,
      'keyPairId' => contracting_resource.session.user.try(:key_pair_id)
    }
  end
end