# encoding: UTF-8
# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20180810130321) do

  create_table "contracting_resources", force: :cascade do |t|
    t.string  "session_id",        null: false
    t.integer "contract_id"
    t.string  "input_resource_id"
    t.string  "service_id"
    t.string  "service_name"
    t.string  "resource_id"
    t.string  "resource_name"
    t.integer "index"
    t.string  "status"
  end

  create_table "contracts", force: :cascade do |t|
    t.integer  "user_id"
    t.string   "resource_id"
    t.string   "resource_name"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "credential_fields", force: :cascade do |t|
    t.string   "name",                    null: false
    t.string   "encrypted_value"
    t.string   "encrypted_value_iv"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "contracting_resource_id"
  end

  create_table "git_accesses", force: :cascade do |t|
    t.string   "session_id"
    t.string   "url"
    t.string   "encrypted_username"
    t.string   "encrypted_username_iv"
    t.string   "encrypted_password"
    t.string   "encrypted_password_iv"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "sessions", id: false, force: :cascade do |t|
    t.string   "id",          limit: 36
    t.integer  "contract_id"
    t.integer  "user_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "settings", force: :cascade do |t|
    t.string   "key",                null: false
    t.string   "encrypted_value"
    t.string   "encrypted_value_iv"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "settings", ["key"], name: "index_settings_on_key"

  create_table "users", force: :cascade do |t|
    t.string   "email",                          null: false
    t.string   "crypted_password"
    t.string   "password_salt"
    t.string   "persistence_token"
    t.string   "full_name",                      null: false
    t.string   "organization"
    t.string   "address"
    t.string   "platform_id"
    t.string   "encrypted_platform_email"
    t.string   "encrypted_platform_email_iv"
    t.string   "encrypted_platform_password"
    t.string   "encrypted_platform_password_iv"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "key_pair_id"
  end

  add_index "users", ["email"], name: "index_users_on_email", unique: true
  add_index "users", ["persistence_token"], name: "index_users_on_persistence_token", unique: true

  create_table "virtual_machines", force: :cascade do |t|
    t.integer "contracting_resource_id"
    t.string  "image"
    t.string  "software_id"
    t.string  "region_id"
    t.string  "instance_type_id"
  end

end
