class DiscoveryConnector
  require 'rest_client'
  require 'rexml/document'

  def self.service_data(resource_id)
    response_to_hash(discovery["api/services/#{resource_id}"].get) rescue nil
  end

  class << self

    private

    def discovery
      etoken = get_authorization_token

      RestClient::Resource.new(
          get_service_url(etoken),
          headers: {'Authorization' => "Bearer #{etoken}"}
      )
    end

    def get_authorization_token
      authorization_params = {
          'username' => Setting.value('discovery_username'),
          'password' => Setting.value('discovery_password')
      }

      resp = RestClient::Resource.new(Setting.value('discovery_url'))['api/authenticate']
                 .post(authorization_params.to_json, content_type: :json)

      JSON.parse(resp)['id_token']
    end

    def get_service_url(etoken)
      # We used to use the correct way to get the URL, but now it runs within the Docker container and returns the
      # internal container IP instead. We temporarily use the shortcut

      "#{Setting.value('discovery_url')}/acsmiservices"

=begin
      resp = RestClient::Resource.new(
          Setting.value('discovery_url'),
          headers: {'Authorization' => "Bearer #{etoken}"})['api/gateway/routes'].get
      JSON.parse(resp)[0]['serviceInstances'][0]['uri']
=end

    end

    def response_to_hash(response)
      JSON.parse(response)
    end
  end
end