/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A Service.
 */
@Entity
@Table(name = "service_attribute_type")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceAttributeType extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(max = 50)
    @Column(name = "name", length = 50, nullable = false)
    private String name;
    
    @Size(max = 20)
    @Column(name = "nfrname", length = 20, nullable = true)
    private String nfrname;
    
    @NotNull
    @Column(name = "isenumeration", nullable = false)
    private Boolean isenumeration;
    
    @NotNull
    @Column(name = "ischecklist", nullable = false)
    private Boolean ischecklist;
    
    @NotNull
    @Column(name = "iscommon", nullable = false)
    private Boolean iscommon;
    
    @NotNull
    @Column(name = "isfunctionalrequirement", nullable = false)
    private Boolean isfunctionalrequirement;
    
    @Column(name = "parentid", nullable = true)
    private Long parentid;
    
    @Column(name = "childid", nullable = true)
    private Long childid;
    
    @Size(max = 20)
    @Column(name = "units", length = 20, nullable = true)
    private String units;
    
    @Size(max = 30)
    @Column(name = "unitfactor", length = 30, nullable = true)
    private String unitfactor;
    
    @Size(max = 2)
    @Column(name = "unitrule", length = 2, nullable = true)
    private String unitrule;
    
    @Size(max = 70)
    @Column(name = "checklistevalrule", length = 70, nullable = true)
    private String checklistevalrule;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    
    public ServiceAttributeType() {}
    
    public ServiceAttributeType(final Long id, final String name, final String nfrname, final Boolean isenumeration,
    		final Boolean ischecklist, final Boolean iscommon, final Boolean isfunctionalrequirement, final Long parentid,
    		final Long childid, final String units, final String unitfactor, final String unitrule,
    		final String checklistevalrule, final ZonedDateTime deleteddate) {
    	this.id = id;
    	this.name = name;
    	this.nfrname = nfrname;
    	this.isenumeration = isenumeration;
    	this.ischecklist = ischecklist;
    	this.iscommon = iscommon;
    	this.isfunctionalrequirement = isfunctionalrequirement;
    	this.parentid = parentid;
    	this.childid = childid;
    	this.units = units;
    	this.unitfactor = unitfactor;
    	this.unitrule = unitrule;
    	this.checklistevalrule = checklistevalrule;
    	this.deleteddate = deleteddate;
    }
    
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public ServiceAttributeType name(String name) {
        this.name = name;
        return this;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    public String getNfrname() {
        return nfrname;
    }

    public ServiceAttributeType nfrname(String nfrname) {
        this.nfrname = nfrname;
        return this;
    }

    public void setNfrname(String nfrname) {
        this.nfrname = nfrname;
    }
    
    public boolean isIsenumeration() {
        return isenumeration;
    }

    public ServiceAttributeType isenumeration(boolean isenumeration) {
        this.isenumeration = isenumeration;
        return this;
    }

    public void setIsenumeration(boolean isenumeration) {
        this.isenumeration = isenumeration;
    }
    
    public boolean isIschecklist() {
        return ischecklist;
    }

    public ServiceAttributeType ischecklist(boolean ischecklist) {
        this.ischecklist = ischecklist;
        return this;
    }

    public void setIschecklist(boolean ischecklist) {
        this.ischecklist = ischecklist;
    }
    
    public boolean isIscommon() {
        return iscommon;
    }

    public ServiceAttributeType iscommon(boolean iscommon) {
        this.iscommon = iscommon;
        return this;
    }

    public void setIscommon(boolean iscommon) {
        this.iscommon = iscommon;
    }

    public boolean isIsfunctionalrequirement() {
        return isfunctionalrequirement;
    }

    public ServiceAttributeType isfunctionalrequirement(boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
        return this;
    }

    public void setIsfunctionalrequirement(boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
    }
    
    public Long getParentid() {
        return parentid;
    }

    public ServiceAttributeType parentid(Long parentid) {
        this.parentid = parentid;
        return this;
    }

    public void setParentid(Long parentid) {
        this.parentid = parentid;
    }
    
    public Long getChildid() {
        return childid;
    }

    public ServiceAttributeType childid(Long childid) {
        this.childid = childid;
        return this;
    }

    public void setChildid(Long childid) {
        this.childid = childid;
    }
    
    public String getUnits() {
        return units;
    }

    public ServiceAttributeType units(String units) {
        this.units = units;
        return this;
    }

    public void setUnits(String units) {
        this.units = units;
    }
    
    public String getUnitfactor() {
        return unitfactor;
    }

    public ServiceAttributeType unitfactor(String unitfactor) {
        this.unitfactor = unitfactor;
        return this;
    }

    public void setUnitfactor(String unitfactor) {
        this.unitfactor = unitfactor;
    }
    
    public String getUnitrule() {
        return unitrule;
    }

    public ServiceAttributeType unitrule(String unitrule) {
        this.unitrule = unitrule;
        return this;
    }

    public void setUnitrule(String unitrule) {
        this.unitrule = unitrule;
    }
    
    public String getChecklistevalrule() {
        return checklistevalrule;
    }

    public ServiceAttributeType checklistevalrule(String checklistevalrule) {
        this.checklistevalrule = checklistevalrule;
        return this;
    }

    public void setChecklistevalrule(String checklistevalrule) {
        this.checklistevalrule = checklistevalrule;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceAttributeType deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceAttributeType serviceAttributeType = (ServiceAttributeType) o;
        if (serviceAttributeType.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceAttributeType.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "Service{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", nfrname='" + getNfrname() + "'" +
            ", isenumeration='" + isIsenumeration() + "'" +
            ", ischecklist='" + isIschecklist() + "'" +
            ", iscommon='" + isIscommon() + "'" +
            ", isfunctionalrequirement='" + isIsfunctionalrequirement() + "'" +
            ", parentid='" + getParentid() + "'" +
            ", childid='" + getChildid() + "'" +
            ", units='" + getUnits() + "'" +
            ", unitfactor='" + getUnitfactor() + "'" +
            ", unitrule='" + getUnitrule() + "'" +
            ", checklistevalrule='" + getChecklistevalrule() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            "}";
    }
}
