/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A Service.
 */
@Entity
@Table(name = "service_attribute_value")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceAttributeValue extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Size(max = 50)
    @Column(name = "serviceattributevalue", length = 50, nullable = true)
    private String serviceattributevalue;
    
    @Size(max = 10)
    @Column(name = "unitvalue", length = 10, nullable = true)
    private String unitvalue;
    
    @Size(max = 40)
    @Column(name = "checklistvalue", length = 40, nullable = true)
    private String checklistvalue;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    @NotNull
    @Column(name = "serviceid", nullable = false)
    private Long serviceid;
    
    @NotNull
    @Column(name = "serviceattributetypeid", nullable = false)
    private Long serviceattributetypeid;
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getServiceattributevalue() {
        return serviceattributevalue;
    }

    public ServiceAttributeValue serviceattributevalue(String serviceattributevalue) {
        this.serviceattributevalue = serviceattributevalue;
        return this;
    }

    public void setServiceattributevalue(String serviceattributevalue) {
        this.serviceattributevalue = serviceattributevalue;
    }
    
    public String getUnitvalue() {
        return unitvalue;
    }

    public ServiceAttributeValue unitvalue(String unitvalue) {
        this.unitvalue = unitvalue;
        return this;
    }

    public void setUnitvalue(String unitvalue) {
        this.unitvalue = unitvalue;
    }
    
    public String getChecklistvalue() {
        return checklistvalue;
    }

    public ServiceAttributeValue checklistvalue(String checklistvalue) {
        this.checklistvalue = checklistvalue;
        return this;
    }

    public void setChecklistvalue(String checklistvalue) {
        this.checklistvalue = checklistvalue;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceAttributeValue deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    
    public Long getServiceid() {
        return serviceid;
    }

    public ServiceAttributeValue serviceid(Long serviceid) {
        this.serviceid = serviceid;
        return this;
    }

    public void setServiceid(Long serviceid) {
        this.serviceid = serviceid;
    }
    
    public Long getServiceattributetypeid() {
        return serviceattributetypeid;
    }

    public ServiceAttributeValue serviceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
        return this;
    }

    public void setServiceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceAttributeValue serviceattributevalue = (ServiceAttributeValue) o;
        if (serviceattributevalue.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceattributevalue.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServiceAttributeValue{" +
            "id=" + getId() +
            ", serviceattributevalue='" + getServiceattributevalue() + "'" +
            ", unitvalue='" + getUnitvalue() + "'" +
            ", checklistvalue='" + getChecklistvalue() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            ", serviceid='" + getServiceid() + "'" +
            ", serviceattributetypeid='" + getServiceattributetypeid() + "'" +
            "}";
    }
}
