/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * A FieldValueVO.
 */
public class FieldValueVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private String name;
    private String value;
    
    
    public FieldValueVO() {
    	name = null;
    	value = null;
    }
    
    public FieldValueVO(String name, String value) {
    	this.name = name;
    	this.value = value;
    }
    
    
    public String getName() {
        return name;
    }
   
    public void setName(final String name) {
        this.name = name;
    }
    
    public String getValue() {
        return value;
    }
   
    public void setValue(final String value) {
        this.value = value;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        FieldValueVO fieldValueVO = (FieldValueVO) o;
        if (fieldValueVO.getName() == null || getName() == null) {
            return false;
        }
        return Objects.equals(getName(), fieldValueVO.getName());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getName());
    }

    @Override
    public String toString() {
    	return "FieldValueVO{" +
                "name=" + getValue() +
                ", value='" + getValue() + "'" +
                "}";
    }
}
