/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * A FilterServiceVO.
 */
public class FilterServiceVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
   
    private Long classid;    
    private List<FilterAttributeVO> attributes;
    
    
    public FilterServiceVO() {
    	this.classid = null;
    	this.attributes = new ArrayList<FilterAttributeVO>();
    }
    
    public FilterServiceVO(final Long classid) {
    	this.classid = classid;
    	this.attributes = new ArrayList<FilterAttributeVO>();
    }
    
    
    public Long getClassid() {
        return classid;
    }

    public void setClassid(final Long classid) {
        this.classid = classid;
    }
    
    public List<FilterAttributeVO> getAttributes() {
    	return attributes;
    }
    
    public void setAttributes(final List<FilterAttributeVO> attributes) {
    	this.attributes = attributes;
    }
    

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        FilterServiceVO filterServiceVO = (FilterServiceVO) o;
        if (filterServiceVO.getClassid() == null || getClassid() == null) {
            return false;
        }
        return Objects.equals(getClassid(), filterServiceVO.getClassid());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getClassid());
    }

    @Override
    public String toString() {
    	StringBuffer ret = new StringBuffer();
    	ret.append("FilterServiceVO{");
    	ret.append("classid=").append(getClassid());
    	ret.append(", attributes=[");
    	for (FilterAttributeVO vo : attributes) {
    		ret.append(vo.toString()).append(",");
    	}
    	ret.append("]");
    	ret.append("}");

    	return ret.toString();
    }
}
