/*******************************************************************************

 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;


/**
 * A ServiceAttributeVO.
 */
public class ServiceAttributeVO implements Serializable, Comparable<ServiceAttributeVO> {

    private static final long serialVersionUID = 1L;
    
    private Long serviceid;
    private String servicename;
    private Long attributetypeid;
    private String attributetypename;
    private String attributetypevalue;
    
    private String attributetypeunitvalue;
    private String attributetypeunits;
    private String attributetypeunitfactor;
    private String attributetypeunitrule;
    
    
    public ServiceAttributeVO(final Long serviceid, final String servicename,
    		final Long attributetypeid, final String attributetypename,
    		final String attributetypevalue, final String attributetypeunitvalue,
    		final String attributetypeunits, final String attributetypeunitfactor,
    		final String attributetypeunitrule) {
    	this.serviceid = serviceid;
    	this.servicename = servicename;
    	this.attributetypeid = attributetypeid;
    	this.attributetypename = attributetypename;
    	this.attributetypevalue = attributetypevalue;
    	this.attributetypeunitvalue = attributetypeunitvalue;
    	this.attributetypeunits = attributetypeunits;
    	this.attributetypeunitfactor = attributetypeunitfactor;
    	this.attributetypeunitrule = attributetypeunitrule;
    }
    
    
    public Long getServiceid() {
        return serviceid;
    }

    public void setServiceid(final Long serviceid) {
        this.serviceid = serviceid;
    }
    
    public String getServicename() {
        return servicename;
    }

    public void setServicename(final String servicename) {
        this.servicename = servicename;
    }
    
    public Long getAttributetypeid() {
        return attributetypeid;
    }

    public void setAttributetypeid(final Long attributetypeid) {
        this.attributetypeid = attributetypeid;
    }
    
    public String getAttributetypename() {
        return attributetypename;
    }

    public void setAttributetypename(final String attributetypename) {
        this.attributetypename = attributetypename;
    }

    public String getAttributetypevalue() {
        return attributetypevalue;
    }
   
    public void setAttributetypevalue(final String attributetypevalue) {
        this.attributetypevalue = attributetypevalue;
    }
    
    public String getAttributetypeunitvalue() {
        return attributetypeunitvalue;
    }

    public void setAttributetypeunitvalue(final String attributetypeunitvalue) {
        this.attributetypeunitvalue = attributetypeunitvalue;
    }
    
    public String getAttributetypeunits() {
        return attributetypeunits;
    }

    public void setAttributetypeunits(final String attributetypeunits) {
        this.attributetypeunits = attributetypeunits;
    }
    
    public String getAttributetypeunitfactor() {
        return attributetypeunitfactor;
    }

    public void setAttributetypeunitfactor(final String attributetypeunitfactor) {
        this.attributetypeunitfactor = attributetypeunitfactor;
    }
    
    public String getAttributetypeunitrule() {
        return attributetypeunitrule;
    }

    public void setAttributetypeunitrule(final String attributetypeunitrule) {
        this.attributetypeunitrule = attributetypeunitrule;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceAttributeVO serviceAttributeVO = (ServiceAttributeVO) o;
        if (serviceAttributeVO.getServiceid() == null || getServiceid() == null) {
            return false;
        }
        return Objects.equals(getServiceid(), serviceAttributeVO.getServiceid());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getServiceid());
    }

    @Override
    public String toString() {
    	return "ServiceAttributeVO{" +
                "serviceid='" + getServiceid() + "'" +
                ", servicename='" + getServicename() + "'" +
                ", attributetypeid='" + getAttributetypeid() + "'" +
                ", attributetypename='" + getAttributetypename() + "'" +
                ", attributetypevalue='" + getAttributetypevalue() + "'" +
                ", attributetypeunitvalue='" + getAttributetypeunitvalue() + "'" +
                ", attributetypeunits='" + getAttributetypeunits() + "'" +
                ", attributetypeunitfactor='" + getAttributetypeunitfactor() + "'" +
                ", attributetypeunitrule='" + getAttributetypeunitrule() + "'" +
                "}";
    }
    
    public int compareTo(ServiceAttributeVO vo) {
    	return this.getServiceid().compareTo(vo.getServiceid());
    }
}
