/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

/**
 * A ServiceFullInfoVO.
 */
public class ServiceFullInfoVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;
    private String name;
    private byte[] firstcontract;
    private byte[] secondcontract;
    private byte[] thirdcontract;
    private Long classid;
    private String classname;
    private Long attributetypeid;
    private String attributename;
    private String attributenfrname;
    private Boolean isenumeration;
    private Boolean ischecklist;
    private Boolean iscommon;
    private Boolean isfunctionalrequirement;
    private Long parentid;
    private Long childid;
    private String units;
    private String unitfactor;
    private String unitrule;
    private String checklistevalrule;
    private String unitvalue;
    private String checklistvalue;
    private Long attributevalueid;
    private String value;
    private String definition;
    private ZonedDateTime deleteddate;
    
    
    public ServiceFullInfoVO() {}    
    
    public ServiceFullInfoVO(final Long id, final String name, final byte[] firstcontract,
    		final byte[] secondcontract, final byte[] thirdcontract, final Long classid, final String classname,
    		final Long attributetypeid, final String attributename, final String attributenfrname,
    		final Boolean isenumeration, final Boolean ischecklist, final Boolean iscommon,
    		final Boolean isfunctionalrequirement, final Long parentid, final Long childid, final String units,
    		final String unitfactor, final String unitrule, final String checklistevalrule, final String unitvalue,
    		final String checklistvalue, final Long attributevalueid, final String value, final String definition,
    		final ZonedDateTime deleteddate) {
    	this.id = id;
    	this.name = name;
    	this.firstcontract = firstcontract;
    	this.secondcontract = secondcontract;
    	this.thirdcontract = thirdcontract;
    	this.classid = classid;
    	this.classname = classname;
    	this.attributetypeid = attributetypeid;
    	this.attributename = attributename;
    	this.attributenfrname = attributenfrname;
    	this.isenumeration = isenumeration;
    	this.ischecklist = ischecklist;
    	this.iscommon = iscommon;
    	this.isfunctionalrequirement = isfunctionalrequirement;
    	this.parentid = parentid;
    	this.childid = childid;
    	this.units = units;
    	this.unitfactor = unitfactor;
    	this.unitrule = unitrule;
    	this.checklistevalrule = checklistevalrule;
    	this.unitvalue = unitvalue;
    	this.checklistvalue = checklistvalue;
    	this.attributevalueid = attributevalueid;
    	this.value = value;
    	this.definition = definition;
    	this.deleteddate = deleteddate;
    }

    

    public Long getId() {
        return id;
    }

    public void setId(final Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }
    
    public byte[] getFirstcontract() {
        return firstcontract;
    }

    public void setFirstcontract(byte[] firstcontract) {
        this.firstcontract = firstcontract;
    }
    
    public byte[] getSecondcontract() {
        return secondcontract;
    }

    public void setSecondcontract(byte[] secondcontract) {
        this.secondcontract = secondcontract;
    }
    
    public byte[] getThirdcontract() {
        return thirdcontract;
    }

    public void setThirdcontract(byte[] thirdcontract) {
        this.thirdcontract = thirdcontract;
    }
    
    public Long getClassid() {
        return classid;
    }
    
    public void setClassid(final Long classid) {
        this.classid = classid;
    }
    
    public String getClassname() {
        return classname;
    }

    public void setClassname(final String classname) {
        this.classname = classname;
    }
    
    public Long getAttributetypeid() {
        return attributetypeid;
    }

    public void setAttributetypeid(final Long attributetypeid) {
        this.attributetypeid = attributetypeid;
    }
    
    public String getAttributename() {
        return attributename;
    }

    public void setAttributename(final String attributename) {
        this.attributename = attributename;
    }
    
    public String getAttributenfrname() {
        return attributenfrname;
    }

    public void setAttributenfrname(final String attributenfrname) {
        this.attributenfrname = attributenfrname;
    }
    
    public Boolean isIsenumeration() {
        return isenumeration;
    }

    public void setIsenumeration(final Boolean isenumeration) {
        this.isenumeration = isenumeration;
    }
    
    public Boolean isIschecklist() {
        return ischecklist;
    }

    public void setIschecklist(final Boolean ischecklist) {
        this.ischecklist = ischecklist;
    }
    
    public Boolean isIscommon() {
        return iscommon;
    }

    public void setIscommon(final Boolean iscommon) {
        this.iscommon = iscommon;
    }
    
    public Boolean isIsfunctionalrequirement() {
        return isfunctionalrequirement;
    }

    public void setIsfunctionalrequirement(final Boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
    }
    
    public Long getParentid() {
        return parentid;
    }

    public void setParentid(final Long parentid) {
        this.parentid = parentid;
    }
    
    public Long getChildid() {
        return childid;
    }

    public void setChildid(final Long childid) {
        this.childid = childid;
    }
    
    public String getUnits() {
        return units;
    }

    public void setUnits(final String units) {
        this.units = units;
    }
    
    public String getUnitfactor() {
        return unitfactor;
    }

    public void setUnitfactor(final String unitfactor) {
        this.unitfactor = unitfactor;
    }
    
    public String getUnitrule() {
        return unitrule;
    }

    public void setUnitrule(final String unitrule) {
        this.unitrule = unitrule;
    }
    
    public String getChecklistevalrule() {
        return checklistevalrule;
    }

    public void setChecklistevalrule(final String checklistevalrule) {
        this.checklistevalrule = checklistevalrule;
    }
    
    public String getUnitvalue() {
        return unitvalue;
    }

    public void setUnitvalue(final String unitvalue) {
        this.unitvalue = unitvalue;
    }
    
    public String getChecklistvalue() {
        return checklistvalue;
    }

    public void setChecklistvalue(final String checklistvalue) {
        this.checklistvalue = checklistvalue;
    }
    
    public Long getAttributevalueid() {
        return attributevalueid;
    }

    public void setAttributevalueid(final Long attributevalueid) {
        this.attributevalueid = attributevalueid;
    }
    
    public String getValue() {
        return value;
    }

    public void setValue(final String value) {
        this.value = value;
    }
    
    public String getDefinition() {
        return definition;
    }

    public void setDefinition(final String definition) {
        this.definition = definition;
    }
    
    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public void setDeleteddate(final ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceFullInfoVO serviceFullInfoVO = (ServiceFullInfoVO) o;
        if (serviceFullInfoVO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceFullInfoVO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServiceFullInfoVO{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", classid='" + getClassid() + "'" +
            ", classname='" + getClassname() + "'" +
            ", attributetypeid='" + getAttributetypeid() + "'" +
            ", attributename='" + getAttributename() + "'" +
            ", attributenfrname='" + getAttributenfrname() + "'" +
            ", isenumeration='" + isIsenumeration() + "'" +            
            ", ischecklist='" + isIschecklist() + "'" +
            ", iscommon='" + isIscommon() + "'" +
            ", isfunctionalrequirement='" + isIsfunctionalrequirement() + "'" +
            ", parentid='" + getParentid() + "'" +
            ", childid='" + getChildid() + "'" +
            ", units='" + getUnits() + "'" +
            ", unitfactor='" + getUnitfactor() + "'" +
            ", unitrule='" + getUnitrule() + "'" +
            ", checklistevalrule='" + getChecklistevalrule() + "'" +
            ", unitvalue='" + getUnitvalue() + "'" +
            ", checklistvalue='" + getChecklistvalue() + "'" +
            ", attributevalueid='" + getAttributevalueid() + "'" +
            ", value='" + getValue() + "'" +
            ", definition='" + getDefinition() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            "}";
    }
}
