/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;

/**
 * A ServiceNFRInfoVO.
 */
public class ServiceNFRInfoExtendedVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private Long serviceid;
    private String servicename;
    private String serviceclassname;
    private String nfrname;
    private String nfrmetric;
    private String nfrvalue;
    private Boolean isenumeration;
    private Boolean iscommonattribute;
    
    
    public ServiceNFRInfoExtendedVO() {
    	serviceid = null;
    	servicename = null;
    	serviceclassname = null;
    	nfrname = null;
    	nfrmetric = null;
    	nfrvalue = null;
    	isenumeration = null;
    	iscommonattribute = null;
    }
    
    public ServiceNFRInfoExtendedVO(final Long serviceid, final String servicename,
    		final String serviceclassname, final String nfrname,
    		final String nfrmetric, final String nfrvalue,
    		final Boolean isenumeration, final Boolean iscommonattribute) {
    	this.serviceid = serviceid;
    	this.servicename = servicename;
    	this.serviceclassname = serviceclassname;
    	this.nfrname = nfrname;
    	this.nfrmetric = nfrmetric;
    	this.nfrvalue = nfrvalue;
    	this.isenumeration = isenumeration;
    	this.iscommonattribute = iscommonattribute;
    }


    public Long getServiceid() {
		return serviceid;
	}

	public void setServiceid(Long serviceid) {
		this.serviceid = serviceid;
	}
	
	public String getServicename() {
		return servicename;
	}

	public void setServicename(String servicename) {
		this.servicename = servicename;
	}
	
	public String getServiceclassname() {
		return serviceclassname;
	}

	public void setServiceclassname(String serviceclassname) {
		this.serviceclassname = serviceclassname;
	}

	public String getNfrname() {
		return nfrname;
	}

	public void setNfrname(String nfrname) {
		this.nfrname = nfrname;
	}
	
	public String getNfrmetric() {
		return nfrmetric;
	}

	public void setNfrmetric(String nfrmetric) {
		this.nfrmetric = nfrmetric;
	}
	
	public String getNfrvalue() {
		return nfrvalue;
	}

	public void setNfrvalue(String nfrvalue) {
		this.nfrvalue = nfrvalue;
	}
	
	public Boolean isIsenumeration() {
		return isenumeration;
	}

	public void setIsenumeration(Boolean isenumeration) {
		this.isenumeration = isenumeration;
	}
	
	public Boolean isIscommonattribute() {
		return iscommonattribute;
	}

	public void setIscommonattribute(Boolean iscommonattribute) {
		this.iscommonattribute = iscommonattribute;
	}
	

	@Override
    public String toString() {
    	return "ServiceNFRInfoExtendedVO{" +
                "serviceid=" + getServiceid() +
                ", servicename='" + getServicename() + "'" +
                ", serviceclassname='" + getServiceclassname() + "'" +
                ", nfrname='" + getNfrname() + "'" +
                ", nfrmetric='" + getNfrmetric() + "'" +
                ", nfrvalue='" + getNfrvalue() + "'" +
                ", isenumeration='" + isIsenumeration() + "'" +
                ", iscommonattribute='" + isIscommonattribute() + "'" +
                "}";
    }
}
