/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import eu.decideh2020.acsmi.backend.services.server.domain.ServiceClassAttribute;


/**
 * Spring Data JPA repository for the ServiceClassAttribute entity.
 */
@Repository
public interface ServiceClassAttributeRepository extends JpaRepository<ServiceClassAttribute,Long> {
	@Query("select new eu.decideh2020.acsmi.backend.services.server.domain.ServiceClassAttribute(t.id, t.weight, t.ismandatory, t.serviceclassid, t.serviceattributetypeid, t.deleteddate, s.name, s.isenumeration, s.ischecklist, s.isfunctionalrequirement, s.parentid, s.childid) from ServiceClassAttribute t join ServiceAttributeType s on t.serviceattributetypeid = s.id where t.serviceclassid = ?1 or t.serviceclassid = 0 order by t.serviceclassid")
	public List<ServiceClassAttribute> findAttributes(Long classid);
}
