/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('ServiceClassController', ServiceClassController);

    ServiceClassController.$inject = ['ServiceClass', 'Service'];

    function ServiceClassController(ServiceClass, Service) {

        var vm = this;

        vm.serviceClasses = [];

        loadAll();

        function loadAll() {
        	// Cargar lista de clases de servicio
        	ServiceClass.query(function(result) {
                vm.serviceClasses = result;
                if (vm.serviceClasses != null && vm.serviceClasses.length > 0) {
                	// Cargar lista de servicios
                	Service.query(function(resultServices) {
                    	vm.services = resultServices;
                    	if (vm.services != null && vm.services.length > 0) {
                    		for (var i = 0;i < vm.serviceClasses.length;i++) {
                    			// Si una clase de servicio es editable, comprobar si tiene servicios asociados
                    			if (vm.serviceClasses[i].editable) {
                    				for (var j = 0;j < vm.services.length;j++) {
                        				if (vm.services[j].serviceclass.id == vm.serviceClasses[i].id) {
                        					vm.serviceClasses[i].editable = false;
                        				}
                        			}
                    			}
                    		}
                    	}
                    });
                }
            });
        }
    }
})();
