/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Alberto Molinuevo                    Tecnalia
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('HomeController', HomeController);

    HomeController.$inject = ['$scope', 'Principal', 'LoginService', 'Service', '$state'];

    function HomeController ($scope, Principal, LoginService, Service, $state) {
        var vm = this;

        vm.account = null;
        vm.isAuthenticated = null;
        vm.login = LoginService.open;
        vm.register = register;
        $scope.$on('authenticationSuccess', function() {
            getAccount();
        });

        getAccount();
        loadDevopsInfo();

        
        function getAccount() {
            Principal.identity().then(function(account) {
                vm.account = account;
                vm.isAuthenticated = Principal.isAuthenticated;
            });
        }
        
        
        function loadDevopsInfo() {
        	Service.devops(function(result) {
            	vm.devops = result;
            	
            	// Organize the information
            	if (result != null && result.length > 0) {
	            	vm.providers = new Array();
	            	vm.serviceClasses = new Array();
	            	vm.data = new Array();
	            	
	            	for (var i = 0;i < result.length;i++) {
	            		if (!vm.providers.includes(result[i].providername)) {
	            			vm.providers.push(result[i].providername);
	            		}
	            		if (!vm.serviceClasses.includes(result[i].serviceclassname)) {
	            			vm.serviceClasses.push(result[i].serviceclassname);
	            		}
	            		vm.data[result[i].serviceclassname + result[i].providername] = result[i].numservices;
	            	}
            	}
            });
        }
        
        
        function register () {
            $state.go('register');
        }
    }
})();
